# This file has been generated by the Catala compiler, do not edit!

from catala.runtime import *
from typing import Any, List, Callable, Tuple
from enum import Enum
from . import France as module__france
from . import Smic as module__smic

class SituationObligationScolaire_Code(Enum):
    Avant = 0
    Pendant = 1
    Apres = 2

class SituationObligationScolaire:
    def __init__(self, code: SituationObligationScolaire_Code, value: Any) -> None:
        self.code = code
        self.value = value


    def __eq__(self, other: object) -> bool:
        if isinstance(other, SituationObligationScolaire):
            return self.code == other.code and self.value == other.value
        else:
            return False


    def __ne__(self, other: object) -> bool:
        return not (self == other)

    def __str__(self) -> str:
        return "{}({})".format(self.code, self.value)

class EnfantPrestationsFamiliales:
    def __init__(self, identifiant: Integer, obligation_scolaire: SituationObligationScolaire, remuneration_mensuelle: Money, date_de_naissance: Date, a_deja_ouvert_droit_aux_allocations_familiales: bool) -> None:
        self.identifiant = identifiant
        self.obligation_scolaire = obligation_scolaire
        self.remuneration_mensuelle = remuneration_mensuelle
        self.date_de_naissance = date_de_naissance
        self.a_deja_ouvert_droit_aux_allocations_familiales = a_deja_ouvert_droit_aux_allocations_familiales

    def __eq__(self, other: object) -> bool:
        if isinstance(other, EnfantPrestationsFamiliales):
            return (self.identifiant == other.identifiant and
                   self.obligation_scolaire == other.obligation_scolaire and
                   self.remuneration_mensuelle == other.remuneration_mensuelle and
                   self.date_de_naissance == other.date_de_naissance and
                   self.a_deja_ouvert_droit_aux_allocations_familiales == other.a_deja_ouvert_droit_aux_allocations_familiales)
        else:
            return False

    def __ne__(self, other: object) -> bool:
        return not (self == other)

    def __str__(self) -> str:
        return "EnfantPrestationsFamiliales(identifiant={},obligation_scolaire={},remuneration_mensuelle={},date_de_naissance={},a_deja_ouvert_droit_aux_allocations_familiales={})".format(self.identifiant,
            self.obligation_scolaire, self.remuneration_mensuelle,
            self.date_de_naissance,
            self.a_deja_ouvert_droit_aux_allocations_familiales)

class EligibilitePrestationsFamiliales:
    def __init__(self, age_l512_3_2: Duration, droit_ouvert: Callable[[EnfantPrestationsFamiliales], bool], conditions_hors_age: Callable[[EnfantPrestationsFamiliales], bool], regime_outre_mer_l751_1: bool) -> None:
        self.age_l512_3_2 = age_l512_3_2
        self.droit_ouvert = droit_ouvert
        self.conditions_hors_age = conditions_hors_age
        self.regime_outre_mer_l751_1 = regime_outre_mer_l751_1

    def __eq__(self, other: object) -> bool:
        if isinstance(other, EligibilitePrestationsFamiliales):
            return (self.age_l512_3_2 == other.age_l512_3_2 and
                   self.droit_ouvert == other.droit_ouvert and
                   self.conditions_hors_age == other.conditions_hors_age and
                   self.regime_outre_mer_l751_1 == other.regime_outre_mer_l751_1)
        else:
            return False

    def __ne__(self, other: object) -> bool:
        return not (self == other)

    def __str__(self) -> str:
        return "EligibilitePrestationsFamiliales(age_l512_3_2={},droit_ouvert={},conditions_hors_age={},regime_outre_mer_l751_1={})".format(self.age_l512_3_2,
            self.droit_ouvert, self.conditions_hors_age,
            self.regime_outre_mer_l751_1)

class EligibilitePrestationsFamilialesIn:
    def __init__(self, date_courante_in: Date, residence_in: module__france.Collectivite, age_l512_3_2_in: Callable[[Unit], Duration]) -> None:
        self.date_courante_in = date_courante_in
        self.residence_in = residence_in
        self.age_l512_3_2_in = age_l512_3_2_in

    def __eq__(self, other: object) -> bool:
        if isinstance(other, EligibilitePrestationsFamilialesIn):
            return (self.date_courante_in == other.date_courante_in and
                   self.residence_in == other.residence_in and
                   self.age_l512_3_2_in == other.age_l512_3_2_in)
        else:
            return False

    def __ne__(self, other: object) -> bool:
        return not (self == other)

    def __str__(self) -> str:
        return "EligibilitePrestationsFamilialesIn(date_courante_in={},residence_in={},age_l512_3_2_in={})".format(self.date_courante_in,
            self.residence_in, self.age_l512_3_2_in)


def eligibilite_prestations_familiales(eligibilite_prestations_familiales_in:EligibilitePrestationsFamilialesIn):
    date_courante = eligibilite_prestations_familiales_in.date_courante_in
    residence = eligibilite_prestations_familiales_in.residence_in
    age_l512_3_2 = eligibilite_prestations_familiales_in.age_l512_3_2_in
    try:
        def temp_age_l512_3_2(_:Unit):
            return age_l512_3_2(Unit())
        def temp_age_l512_3_2_1(_:Unit):
            return True
        def temp_age_l512_3_2_2(_:Unit):
            try:
                def temp_age_l512_3_2_3(_:Unit):
                    def temp_age_l512_3_2_4(_:Unit):
                        return log_decision_taken(SourcePosition(filename="prestations_familiales/sécurité_sociale_R.catala_fr",
                            start_line=21, start_column=14,
                            end_line=21, end_column=26,
                            law_headings=["Article R512-2",
                            "Chapitre 2 : Champ d'application.",
                            "Titre 1 : Champ d'application - Généralités",
                            "Livre 5 : Prestations familiales et prestations assimilées",
                            "Partie réglementaire - Décrets en Conseil d'Etat",
                            "Code de la sécurité sociale"]), True)
                    def temp_age_l512_3_2_5(_:Unit):
                        return duration_of_numbers(20,0,0)
                    return handle_default(SourcePosition(filename="prestations_familiales/sécurité_sociale_R.catala_fr",
                                          start_line=21, start_column=34,
                                          end_line=21, end_column=39,
                                          law_headings=["Article R512-2",
                                          "Chapitre 2 : Champ d'application.",
                                          "Titre 1 : Champ d'application - Généralités",
                                          "Livre 5 : Prestations familiales et prestations assimilées",
                                          "Partie réglementaire - Décrets en Conseil d'Etat",
                                          "Code de la sécurité sociale"]), [],
                                          temp_age_l512_3_2_4,
                                          temp_age_l512_3_2_5)
                def temp_age_l512_3_2_6(_:Unit):
                    return False
                def temp_age_l512_3_2_7(_:Unit):
                    raise Empty
                return handle_default(SourcePosition(filename="prestations_familiales/prologue.catala_fr",
                                      start_line=26, start_column=21,
                                      end_line=26, end_column=33,
                                      law_headings=["Prologue : prestations familiales"]), [temp_age_l512_3_2_3],
                                      temp_age_l512_3_2_6,
                                      temp_age_l512_3_2_7)
            except Empty:
                raise NoValue(SourcePosition(
                                  filename="prestations_familiales/prologue.catala_fr",
                                  start_line=26, start_column=21,
                                  end_line=26, end_column=33,
                                  law_headings=["Prologue : prestations familiales"]
                              ))
        temp_age_l512_3_2_8 = handle_default(SourcePosition(filename="prestations_familiales/prologue.catala_fr",
                                             start_line=26, start_column=21,
                                             end_line=26, end_column=33,
                                             law_headings=["Prologue : prestations familiales"]), [temp_age_l512_3_2],
                                             temp_age_l512_3_2_1,
                                             temp_age_l512_3_2_2)
    except Empty:
        raise NoValue(SourcePosition(
                          filename="prestations_familiales/prologue.catala_fr",
                          start_line=26, start_column=21,
                          end_line=26, end_column=33,
                          law_headings=["Prologue : prestations familiales"]))
    age_l512_3_2_1 = log_variable_definition(["ÉligibilitéPrestationsFamiliales",
        "âge_l512_3_2"], LogIO(input_io=InputIO.Reentrant, output_io=True),
        temp_age_l512_3_2_8)
    try:
        def temp_result(_:Unit):
            def temp_result_1(_:Unit):
                return log_decision_taken(SourcePosition(filename="prestations_familiales/prologue.catala_fr",
                    start_line=37, start_column=14,
                    end_line=37, end_column=32,
                    law_headings=["Prologue : prestations familiales"]), True)
            def temp_result_2(_:Unit):
                return date_courante
            return handle_default(SourcePosition(filename="prestations_familiales/prologue.catala_fr",
                                  start_line=37, start_column=40,
                                  end_line=37, end_column=53,
                                  law_headings=["Prologue : prestations familiales"]), [],
                                  temp_result_1, temp_result_2)
        def temp_result_3(_:Unit):
            return False
        def temp_result_4(_:Unit):
            raise Empty
        temp_result_5 = handle_default(SourcePosition(filename="prestations_familiales/prologue.catala_fr",
                                       start_line=37, start_column=14,
                                       end_line=37, end_column=32,
                                       law_headings=["Prologue : prestations familiales"]), [temp_result],
                                       temp_result_3, temp_result_4)
    except Empty:
        raise NoValue(SourcePosition(
                          filename="prestations_familiales/prologue.catala_fr",
                          start_line=37, start_column=14,
                          end_line=37, end_column=32,
                          law_headings=["Prologue : prestations familiales"]))
    try:
        def temp_result_6(_:Unit):
            def temp_result_7(_:Unit):
                return log_decision_taken(SourcePosition(filename="prestations_familiales/prologue.catala_fr",
                    start_line=36, start_column=14,
                    end_line=36, end_column=28,
                    law_headings=["Prologue : prestations familiales"]), True)
            def temp_result_8(_:Unit):
                return residence
            return handle_default(SourcePosition(filename="prestations_familiales/prologue.catala_fr",
                                  start_line=36, start_column=36,
                                  end_line=36, end_column=45,
                                  law_headings=["Prologue : prestations familiales"]), [],
                                  temp_result_7, temp_result_8)
        def temp_result_9(_:Unit):
            return False
        def temp_result_10(_:Unit):
            raise Empty
        temp_result_11 = handle_default(SourcePosition(filename="prestations_familiales/prologue.catala_fr",
                                        start_line=36, start_column=14,
                                        end_line=36, end_column=28,
                                        law_headings=["Prologue : prestations familiales"]), [temp_result_6],
                                        temp_result_9, temp_result_10)
    except Empty:
        raise NoValue(SourcePosition(
                          filename="prestations_familiales/prologue.catala_fr",
                          start_line=36, start_column=14,
                          end_line=36, end_column=28,
                          law_headings=["Prologue : prestations familiales"]))
    result = log_begin_call(["Smic", "direct"], module__smic.smic,
        log_variable_definition(["Smic", "direct", "input"],
        LogIO(input_io=InputIO.OnlyInput, output_io=False),
        module__smic.SmicIn(date_courante_in = temp_result_5,
        residence_in = temp_result_11)))
    result_1 = module__smic.Smic(brut_horaire = result.brut_horaire)
    if log_decision_taken(SourcePosition(filename="prestations_familiales/prologue.catala_fr",
        start_line=33, start_column=3, end_line=33, end_column=7,
        law_headings=["Prologue : prestations familiales"]), True):
        temp_smic = result_1
    else:
        temp_smic = result_1
    smic = log_variable_definition(["ÉligibilitéPrestationsFamiliales",
        "smic"], LogIO(input_io=InputIO.NoInput, output_io=False),
        log_end_call(["Smic", "direct"], log_variable_definition(["Smic",
        "direct", "output"], LogIO(input_io=InputIO.NoInput, output_io=True),
        temp_smic)))
    try:
        def temp_regime_outre_mer_l751_1(_:Unit):
            def temp_regime_outre_mer_l751_1_1(_:Unit):
                def temp_regime_outre_mer_l751_1_2(_:Unit):
                    return log_decision_taken(SourcePosition(filename="prestations_familiales/sécurité_sociale_L.catala_fr",
                        start_line=123, start_column=5,
                        end_line=128, end_column=30,
                        law_headings=["Article L751-1",
                        "Chapitre 1er : Généralités",
                        "Titre 5 : Dispositions particulières à la Guadeloupe, à la Guyane, à la Martinique, à La Réunion, à Saint-Barthélemy et à Saint-Martin",
                        "Livre 7 : Régimes divers - Dispositions diverses",
                        "Partie législative",
                        "Code de la sécurité sociale"]), ((residence ==
                        module__france.Collectivite(module__france.Collectivite_Code.Guadeloupe,
                        Unit())) or ((residence ==
                        module__france.Collectivite(module__france.Collectivite_Code.Guyane,
                        Unit())) or ((residence ==
                        module__france.Collectivite(module__france.Collectivite_Code.Martinique,
                        Unit())) or ((residence ==
                        module__france.Collectivite(module__france.Collectivite_Code.LaReunion,
                        Unit())) or ((residence ==
                        module__france.Collectivite(module__france.Collectivite_Code.SaintBarthelemy,
                        Unit())) or (residence ==
                        module__france.Collectivite(module__france.Collectivite_Code.SaintMartin,
                        Unit()))))))))
                def temp_regime_outre_mer_l751_1_3(_:Unit):
                    return True
                return handle_default(SourcePosition(filename="prestations_familiales/sécurité_sociale_L.catala_fr",
                                      start_line=129, start_column=14,
                                      end_line=129, end_column=21,
                                      law_headings=["Article L751-1",
                                      "Chapitre 1er : Généralités",
                                      "Titre 5 : Dispositions particulières à la Guadeloupe, à la Guyane, à la Martinique, à La Réunion, à Saint-Barthélemy et à Saint-Martin",
                                      "Livre 7 : Régimes divers - Dispositions diverses",
                                      "Partie législative",
                                      "Code de la sécurité sociale"]), [],
                                      temp_regime_outre_mer_l751_1_2,
                                      temp_regime_outre_mer_l751_1_3)
            def temp_regime_outre_mer_l751_1_4(_:Unit):
                return False
            def temp_regime_outre_mer_l751_1_5(_:Unit):
                raise Empty
            return handle_default(SourcePosition(filename="prestations_familiales/prologue.catala_fr",
                                  start_line=31, start_column=12,
                                  end_line=31, end_column=35,
                                  law_headings=["Prologue : prestations familiales"]), [temp_regime_outre_mer_l751_1_1],
                                  temp_regime_outre_mer_l751_1_4,
                                  temp_regime_outre_mer_l751_1_5)
        def temp_regime_outre_mer_l751_1_6(_:Unit):
            return True
        def temp_regime_outre_mer_l751_1_7(_:Unit):
            def temp_regime_outre_mer_l751_1_8(_:Unit):
                def temp_regime_outre_mer_l751_1_9(_:Unit):
                    return log_decision_taken(SourcePosition(filename="prestations_familiales/prologue.catala_fr",
                        start_line=31, start_column=12,
                        end_line=31, end_column=35,
                        law_headings=["Prologue : prestations familiales"]), True)
                def temp_regime_outre_mer_l751_1_10(_:Unit):
                    return False
                return handle_default(SourcePosition(filename="prestations_familiales/prologue.catala_fr",
                                      start_line=31, start_column=12,
                                      end_line=31, end_column=35,
                                      law_headings=["Prologue : prestations familiales"]), [],
                                      temp_regime_outre_mer_l751_1_9,
                                      temp_regime_outre_mer_l751_1_10)
            def temp_regime_outre_mer_l751_1_11(_:Unit):
                return False
            def temp_regime_outre_mer_l751_1_12(_:Unit):
                raise Empty
            return handle_default(SourcePosition(filename="prestations_familiales/prologue.catala_fr",
                                  start_line=31, start_column=12,
                                  end_line=31, end_column=35,
                                  law_headings=["Prologue : prestations familiales"]), [temp_regime_outre_mer_l751_1_8],
                                  temp_regime_outre_mer_l751_1_11,
                                  temp_regime_outre_mer_l751_1_12)
        temp_regime_outre_mer_l751_1_13 = handle_default(SourcePosition(filename="prestations_familiales/prologue.catala_fr",
                                                         start_line=31,
                                                         start_column=12,
                                                         end_line=31, end_column=35,
                                                         law_headings=["Prologue : prestations familiales"]), [temp_regime_outre_mer_l751_1],
                                                         temp_regime_outre_mer_l751_1_6,
                                                         temp_regime_outre_mer_l751_1_7)
    except Empty:
        raise NoValue(SourcePosition(
                          filename="prestations_familiales/prologue.catala_fr",
                          start_line=31, start_column=12,
                          end_line=31, end_column=35,
                          law_headings=["Prologue : prestations familiales"]))
    regime_outre_mer_l751_1 = log_variable_definition(["ÉligibilitéPrestationsFamiliales",
        "régime_outre_mer_l751_1"], LogIO(input_io=InputIO.NoInput,
        output_io=True), temp_regime_outre_mer_l751_1_13)
    try:
        def temp_plafond_l512_3_2(_:Unit):
            def temp_plafond_l512_3_2_1(_:Unit):
                def temp_plafond_l512_3_2_2(_:Unit):
                    return log_decision_taken(SourcePosition(filename="prestations_familiales/sécurité_sociale_R.catala_fr",
                        start_line=62, start_column=18,
                        end_line=62, end_column=41,
                        law_headings=["Article R755-0-2",
                        "Chapitre 5 : Prestations familiales et prestations assimilées",
                        "Titre 5 : Départements d'outre-mer",
                        "Livre 7 : Régimes divers - Dispositions diverses",
                        "Partie réglementaire - Décrets en Conseil d'Etat",
                        "Code de la sécurité sociale"]), regime_outre_mer_l751_1)
                def temp_plafond_l512_3_2_3(_:Unit):
                    return ((smic.brut_horaire * decimal_of_string("0.55")) *
                        decimal_of_string("169."))
                return handle_default(SourcePosition(filename="prestations_familiales/sécurité_sociale_R.catala_fr",
                                      start_line=64, start_column=5,
                                      end_line=64, end_column=38,
                                      law_headings=["Article R755-0-2",
                                      "Chapitre 5 : Prestations familiales et prestations assimilées",
                                      "Titre 5 : Départements d'outre-mer",
                                      "Livre 7 : Régimes divers - Dispositions diverses",
                                      "Partie réglementaire - Décrets en Conseil d'Etat",
                                      "Code de la sécurité sociale"]), [],
                                      temp_plafond_l512_3_2_2,
                                      temp_plafond_l512_3_2_3)
            def temp_plafond_l512_3_2_4(_:Unit):
                return False
            def temp_plafond_l512_3_2_5(_:Unit):
                raise Empty
            return handle_default(SourcePosition(filename="prestations_familiales/prologue.catala_fr",
                                  start_line=24, start_column=11,
                                  end_line=24, end_column=27,
                                  law_headings=["Prologue : prestations familiales"]), [temp_plafond_l512_3_2_1],
                                  temp_plafond_l512_3_2_4,
                                  temp_plafond_l512_3_2_5)
        def temp_plafond_l512_3_2_6(_:Unit):
            return True
        def temp_plafond_l512_3_2_7(_:Unit):
            def temp_plafond_l512_3_2_8(_:Unit):
                def temp_plafond_l512_3_2_9(_:Unit):
                    return log_decision_taken(SourcePosition(filename="prestations_familiales/sécurité_sociale_R.catala_fr",
                        start_line=31, start_column=14,
                        end_line=31, end_column=30,
                        law_headings=["Article R512-2",
                        "Chapitre 2 : Champ d'application.",
                        "Titre 1 : Champ d'application - Généralités",
                        "Livre 5 : Prestations familiales et prestations assimilées",
                        "Partie réglementaire - Décrets en Conseil d'Etat",
                        "Code de la sécurité sociale"]), True)
                def temp_plafond_l512_3_2_10(_:Unit):
                    return ((smic.brut_horaire * decimal_of_string("0.55")) *
                        decimal_of_string("169."))
                return handle_default(SourcePosition(filename="prestations_familiales/sécurité_sociale_R.catala_fr",
                                      start_line=32, start_column=4,
                                      end_line=32, end_column=38,
                                      law_headings=["Article R512-2",
                                      "Chapitre 2 : Champ d'application.",
                                      "Titre 1 : Champ d'application - Généralités",
                                      "Livre 5 : Prestations familiales et prestations assimilées",
                                      "Partie réglementaire - Décrets en Conseil d'Etat",
                                      "Code de la sécurité sociale"]), [],
                                      temp_plafond_l512_3_2_9,
                                      temp_plafond_l512_3_2_10)
            def temp_plafond_l512_3_2_11(_:Unit):
                return False
            def temp_plafond_l512_3_2_12(_:Unit):
                raise Empty
            return handle_default(SourcePosition(filename="prestations_familiales/prologue.catala_fr",
                                  start_line=24, start_column=11,
                                  end_line=24, end_column=27,
                                  law_headings=["Prologue : prestations familiales"]), [temp_plafond_l512_3_2_8],
                                  temp_plafond_l512_3_2_11,
                                  temp_plafond_l512_3_2_12)
        temp_plafond_l512_3_2_13 = handle_default(SourcePosition(filename="prestations_familiales/prologue.catala_fr",
                                                  start_line=24,
                                                  start_column=11,
                                                  end_line=24, end_column=27,
                                                  law_headings=["Prologue : prestations familiales"]), [temp_plafond_l512_3_2],
                                                  temp_plafond_l512_3_2_6,
                                                  temp_plafond_l512_3_2_7)
    except Empty:
        raise NoValue(SourcePosition(
                          filename="prestations_familiales/prologue.catala_fr",
                          start_line=24, start_column=11,
                          end_line=24, end_column=27,
                          law_headings=["Prologue : prestations familiales"]))
    plafond_l512_3_2 = log_variable_definition(["ÉligibilitéPrestationsFamiliales",
        "plafond_l512_3_2"], LogIO(input_io=InputIO.NoInput,
        output_io=False), temp_plafond_l512_3_2_13)
    def temp_conditions_hors_age(enfant:EnfantPrestationsFamiliales):
        try:
            def temp_conditions_hors_age_1(_:Unit):
                def temp_conditions_hors_age_2(_:Unit):
                    def temp_conditions_hors_age_3(_:Unit):
                        match_arg = enfant.obligation_scolaire
                        if match_arg.code == SituationObligationScolaire_Code.Avant:
                            _ = match_arg.value
                            temp_conditions_hors_age_4 = True
                        elif match_arg.code == SituationObligationScolaire_Code.Pendant:
                            _ = match_arg.value
                            temp_conditions_hors_age_4 = False
                        elif match_arg.code == SituationObligationScolaire_Code.Apres:
                            _ = match_arg.value
                            temp_conditions_hors_age_4 = False
                        match_arg_1 = enfant.obligation_scolaire
                        if match_arg_1.code == SituationObligationScolaire_Code.Avant:
                            _ = match_arg_1.value
                            temp_conditions_hors_age_5 = False
                        elif match_arg_1.code == SituationObligationScolaire_Code.Pendant:
                            _ = match_arg_1.value
                            temp_conditions_hors_age_5 = True
                        elif match_arg_1.code == SituationObligationScolaire_Code.Apres:
                            _ = match_arg_1.value
                            temp_conditions_hors_age_5 = False
                        match_arg_2 = enfant.obligation_scolaire
                        if match_arg_2.code == SituationObligationScolaire_Code.Avant:
                            _ = match_arg_2.value
                            temp_conditions_hors_age_6 = False
                        elif match_arg_2.code == SituationObligationScolaire_Code.Pendant:
                            _ = match_arg_2.value
                            temp_conditions_hors_age_6 = False
                        elif match_arg_2.code == SituationObligationScolaire_Code.Apres:
                            _ = match_arg_2.value
                            temp_conditions_hors_age_6 = True
                        return log_decision_taken(SourcePosition(filename="prestations_familiales/sécurité_sociale_L.catala_fr",
                            start_line=74, start_column=5,
                            end_line=78, end_column=24,
                            law_headings=["Article L512-3",
                            "Chapitre 2 : Champ d'application",
                            "Titre 1 : Champ d'application - Généralités",
                            "Livre 5 : Prestations familiales et prestations assimilées",
                            "Partie législative",
                            "Code de la sécurité sociale"]), ((temp_conditions_hors_age_4 or
                            (temp_conditions_hors_age_5 or
                            temp_conditions_hors_age_6)) and
                            (enfant.remuneration_mensuelle <=
                            plafond_l512_3_2)))
                    def temp_conditions_hors_age_7(_:Unit):
                        return True
                    return handle_default(SourcePosition(filename="prestations_familiales/sécurité_sociale_L.catala_fr",
                                          start_line=79, start_column=14,
                                          end_line=79, end_column=21,
                                          law_headings=["Article L512-3",
                                          "Chapitre 2 : Champ d'application",
                                          "Titre 1 : Champ d'application - Généralités",
                                          "Livre 5 : Prestations familiales et prestations assimilées",
                                          "Partie législative",
                                          "Code de la sécurité sociale"]), [],
                                          temp_conditions_hors_age_3,
                                          temp_conditions_hors_age_7)
                def temp_conditions_hors_age_8(_:Unit):
                    return False
                def temp_conditions_hors_age_9(_:Unit):
                    raise Empty
                return handle_default(SourcePosition(filename="prestations_familiales/prologue.catala_fr",
                                      start_line=29, start_column=12,
                                      end_line=29, end_column=31,
                                      law_headings=["Prologue : prestations familiales"]), [temp_conditions_hors_age_2],
                                      temp_conditions_hors_age_8,
                                      temp_conditions_hors_age_9)
            def temp_conditions_hors_age_10(_:Unit):
                return True
            def temp_conditions_hors_age_11(_:Unit):
                def temp_conditions_hors_age_12(_:Unit):
                    def temp_conditions_hors_age_13(_:Unit):
                        return log_decision_taken(SourcePosition(filename="prestations_familiales/prologue.catala_fr",
                            start_line=29, start_column=12,
                            end_line=29, end_column=31,
                            law_headings=["Prologue : prestations familiales"]), True)
                    def temp_conditions_hors_age_14(_:Unit):
                        return False
                    return handle_default(SourcePosition(filename="prestations_familiales/prologue.catala_fr",
                                          start_line=29, start_column=12,
                                          end_line=29, end_column=31,
                                          law_headings=["Prologue : prestations familiales"]), [],
                                          temp_conditions_hors_age_13,
                                          temp_conditions_hors_age_14)
                def temp_conditions_hors_age_15(_:Unit):
                    return False
                def temp_conditions_hors_age_16(_:Unit):
                    raise Empty
                return handle_default(SourcePosition(filename="prestations_familiales/prologue.catala_fr",
                                      start_line=29, start_column=12,
                                      end_line=29, end_column=31,
                                      law_headings=["Prologue : prestations familiales"]), [temp_conditions_hors_age_12],
                                      temp_conditions_hors_age_15,
                                      temp_conditions_hors_age_16)
            return handle_default(SourcePosition(filename="prestations_familiales/prologue.catala_fr",
                                  start_line=29, start_column=12,
                                  end_line=29, end_column=31,
                                  law_headings=["Prologue : prestations familiales"]), [temp_conditions_hors_age_1],
                                  temp_conditions_hors_age_10,
                                  temp_conditions_hors_age_11)
        except Empty:
            raise NoValue(SourcePosition(
                              filename="prestations_familiales/prologue.catala_fr",
                              start_line=29, start_column=12,
                              end_line=29, end_column=31,
                              law_headings=["Prologue : prestations familiales"]
                          ))
    conditions_hors_age = log_variable_definition(["ÉligibilitéPrestationsFamiliales",
        "conditions_hors_âge"], LogIO(input_io=InputIO.NoInput,
        output_io=True), temp_conditions_hors_age)
    def temp_droit_ouvert(enfant_1:EnfantPrestationsFamiliales):
        try:
            def temp_droit_ouvert_1(_:Unit):
                def temp_droit_ouvert_2(_:Unit):
                    def temp_droit_ouvert_3(_:Unit):
                        def temp_droit_ouvert_4(_:Unit):
                            match_arg_3 = enfant_1.obligation_scolaire
                            if match_arg_3.code == SituationObligationScolaire_Code.Avant:
                                _ = match_arg_3.value
                                temp_droit_ouvert_5 = False
                            elif match_arg_3.code == SituationObligationScolaire_Code.Pendant:
                                _ = match_arg_3.value
                                temp_droit_ouvert_5 = False
                            elif match_arg_3.code == SituationObligationScolaire_Code.Apres:
                                _ = match_arg_3.value
                                temp_droit_ouvert_5 = True
                            result_2 = log_begin_call(["VérificationÂgeSupérieurÀ",
                                "direct"],
                                module__france.verification_age_superieur_a,
                                log_variable_definition(["VérificationÂgeSupérieurÀ",
                                "direct", "input"],
                                LogIO(input_io=InputIO.OnlyInput,
                                output_io=False),
                                module__france.VerificationAgeSuperieurAIn(date_naissance_in = enfant_1.date_de_naissance,
                                date_courante_in = date_courante,
                                annees_in = age_l512_3_2_1)))
                            result_3 = module__france.VerificationAgeSuperieurA(est_superieur = result_2.est_superieur)
                            if log_decision_taken(SourcePosition(filename="prestations_familiales/sécurité_sociale_L.catala_fr",
                                start_line=65, start_column=6,
                                end_line=68, end_column=44,
                                law_headings=["Article L512-3",
                                "Chapitre 2 : Champ d'application",
                                "Titre 1 : Champ d'application - Généralités",
                                "Livre 5 : Prestations familiales et prestations assimilées",
                                "Partie législative",
                                "Code de la sécurité sociale"]), True):
                                temp_droit_ouvert_6 = result_3
                            else:
                                temp_droit_ouvert_6 = result_3
                            return log_decision_taken(SourcePosition(filename="prestations_familiales/sécurité_sociale_L.catala_fr",
                                start_line=63, start_column=5,
                                end_line=68, end_column=59,
                                law_headings=["Article L512-3",
                                "Chapitre 2 : Champ d'application",
                                "Titre 1 : Champ d'application - Généralités",
                                "Livre 5 : Prestations familiales et prestations assimilées",
                                "Partie législative",
                                "Code de la sécurité sociale"]), (temp_droit_ouvert_5 and
                                ((enfant_1.remuneration_mensuelle <=
                                plafond_l512_3_2) and
                                log_end_call(["VérificationÂgeSupérieurÀ",
                                "direct"],
                                log_variable_definition(["VérificationÂgeSupérieurÀ",
                                "direct", "output"],
                                LogIO(input_io=InputIO.NoInput,
                                output_io=True),
                                temp_droit_ouvert_6)).est_superieur)))
                        def temp_droit_ouvert_7(_:Unit):
                            return True
                        return handle_default(SourcePosition(filename="prestations_familiales/sécurité_sociale_L.catala_fr",
                                              start_line=69, start_column=14,
                                              end_line=69, end_column=21,
                                              law_headings=["Article L512-3",
                                              "Chapitre 2 : Champ d'application",
                                              "Titre 1 : Champ d'application - Généralités",
                                              "Livre 5 : Prestations familiales et prestations assimilées",
                                              "Partie législative",
                                              "Code de la sécurité sociale"]), [],
                                              temp_droit_ouvert_4,
                                              temp_droit_ouvert_7)
                    def temp_droit_ouvert_8(_:Unit):
                        match_arg_4 = enfant_1.obligation_scolaire
                        if match_arg_4.code == SituationObligationScolaire_Code.Avant:
                            _ = match_arg_4.value
                            temp_droit_ouvert_9 = True
                        elif match_arg_4.code == SituationObligationScolaire_Code.Pendant:
                            _ = match_arg_4.value
                            temp_droit_ouvert_9 = False
                        elif match_arg_4.code == SituationObligationScolaire_Code.Apres:
                            _ = match_arg_4.value
                            temp_droit_ouvert_9 = False
                        match_arg_5 = enfant_1.obligation_scolaire
                        if match_arg_5.code == SituationObligationScolaire_Code.Avant:
                            _ = match_arg_5.value
                            temp_droit_ouvert_10 = False
                        elif match_arg_5.code == SituationObligationScolaire_Code.Pendant:
                            _ = match_arg_5.value
                            temp_droit_ouvert_10 = True
                        elif match_arg_5.code == SituationObligationScolaire_Code.Apres:
                            _ = match_arg_5.value
                            temp_droit_ouvert_10 = False
                        return log_decision_taken(SourcePosition(filename="prestations_familiales/sécurité_sociale_L.catala_fr",
                            start_line=52, start_column=5,
                            end_line=53, end_column=50,
                            law_headings=["Article L512-3",
                            "Chapitre 2 : Champ d'application",
                            "Titre 1 : Champ d'application - Généralités",
                            "Livre 5 : Prestations familiales et prestations assimilées",
                            "Partie législative",
                            "Code de la sécurité sociale"]), (temp_droit_ouvert_9 or
                            temp_droit_ouvert_10))
                    def temp_droit_ouvert_11(_:Unit):
                        return True
                    return handle_default(SourcePosition(filename="prestations_familiales/sécurité_sociale_L.catala_fr",
                                          start_line=54, start_column=14,
                                          end_line=54, end_column=21,
                                          law_headings=["Article L512-3",
                                          "Chapitre 2 : Champ d'application",
                                          "Titre 1 : Champ d'application - Généralités",
                                          "Livre 5 : Prestations familiales et prestations assimilées",
                                          "Partie législative",
                                          "Code de la sécurité sociale"]), [temp_droit_ouvert_3],
                                          temp_droit_ouvert_8,
                                          temp_droit_ouvert_11)
                def temp_droit_ouvert_12(_:Unit):
                    return False
                def temp_droit_ouvert_13(_:Unit):
                    raise Empty
                return handle_default(SourcePosition(filename="prestations_familiales/prologue.catala_fr",
                                      start_line=27, start_column=12,
                                      end_line=27, end_column=24,
                                      law_headings=["Prologue : prestations familiales"]), [temp_droit_ouvert_2],
                                      temp_droit_ouvert_12,
                                      temp_droit_ouvert_13)
            def temp_droit_ouvert_14(_:Unit):
                return True
            def temp_droit_ouvert_15(_:Unit):
                def temp_droit_ouvert_16(_:Unit):
                    def temp_droit_ouvert_17(_:Unit):
                        return log_decision_taken(SourcePosition(filename="prestations_familiales/prologue.catala_fr",
                            start_line=27, start_column=12,
                            end_line=27, end_column=24,
                            law_headings=["Prologue : prestations familiales"]), True)
                    def temp_droit_ouvert_18(_:Unit):
                        return False
                    return handle_default(SourcePosition(filename="prestations_familiales/prologue.catala_fr",
                                          start_line=27, start_column=12,
                                          end_line=27, end_column=24,
                                          law_headings=["Prologue : prestations familiales"]), [],
                                          temp_droit_ouvert_17,
                                          temp_droit_ouvert_18)
                def temp_droit_ouvert_19(_:Unit):
                    return False
                def temp_droit_ouvert_20(_:Unit):
                    raise Empty
                return handle_default(SourcePosition(filename="prestations_familiales/prologue.catala_fr",
                                      start_line=27, start_column=12,
                                      end_line=27, end_column=24,
                                      law_headings=["Prologue : prestations familiales"]), [temp_droit_ouvert_16],
                                      temp_droit_ouvert_19,
                                      temp_droit_ouvert_20)
            return handle_default(SourcePosition(filename="prestations_familiales/prologue.catala_fr",
                                  start_line=27, start_column=12,
                                  end_line=27, end_column=24,
                                  law_headings=["Prologue : prestations familiales"]), [temp_droit_ouvert_1],
                                  temp_droit_ouvert_14, temp_droit_ouvert_15)
        except Empty:
            raise NoValue(SourcePosition(
                              filename="prestations_familiales/prologue.catala_fr",
                              start_line=27, start_column=12,
                              end_line=27, end_column=24,
                              law_headings=["Prologue : prestations familiales"]
                          ))
    droit_ouvert = log_variable_definition(["ÉligibilitéPrestationsFamiliales",
        "droit_ouvert"], LogIO(input_io=InputIO.NoInput, output_io=True),
        temp_droit_ouvert)
    return EligibilitePrestationsFamiliales(age_l512_3_2 = age_l512_3_2_1,
        droit_ouvert = droit_ouvert,
        conditions_hors_age = conditions_hors_age,
        regime_outre_mer_l751_1 = regime_outre_mer_l751_1)
